var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Version } from '@microsoft/sp-core-library';
import { BaseClientSideWebPart, PropertyPaneTextField } from '@microsoft/sp-webpart-base';
import styles from './ZhPnPjsWebPart.module.scss';
import * as strings from 'ZhPnPjsWebPartStrings';
import { sp } from "@pnp/sp";
var ZhPnPjsWebPart = /** @class */ (function (_super) {
    __extends(ZhPnPjsWebPart, _super);
    function ZhPnPjsWebPart() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ZhPnPjsWebPart.prototype.render = function () {
        var _this = this;
        //#region - Setup
        var resultsHTML = '';
        var expireDate = new Date();
        expireDate.setDate(expireDate.getDate() + 1);
        sp.setup({
            spfxContext: this.context
        });
        //#endregion
        // get all the items from a list
        sp.web.lists.getByTitle("CommunityContributors").items.select('Title', 'Twitter', 'Blog').orderBy('Created', true)
            .usingCaching({
            //expiration: dateAdd(new Date(), "minute", 5),
            //expiration: (expireDate.setDate(expireDate.getDate() + 1)),
            //expiration: dateAdd(new Date(), "minute", 20),
            expiration: expireDate,
            key: "zhFirstGearListData",
            storeName: "session" // or "local"
        })
            .get().then(function (items) {
            _this.domElement.innerHTML = _this.generateHTML(items);
            //resultsHTML = this.generateHTML(items);
            //this.domElement.innerHTML = resultsHTML;
        });
    };
    ZhPnPjsWebPart.prototype.generateHTML = function (listItems) {
        var html = '';
        for (var i = 0; i < listItems.length; i++) {
            var contributor = listItems[i];
            console.log(contributor);
            var itemHTML = "\n        <div class=\"" + styles["singleCommunityMember"] + "\">\n          <div class=\"" + styles["communityMemberInner"] + "\">\n            <div class=\"" + styles["communityMemberBiopic"] + "\"> \n              <span>\n                <img src=\"https://avatars.io/twitter/" + contributor.Twitter + "\"/>\n              </span> \n            </div>\n            <div class=\"" + styles["communityMemberSocialDetails"] + "\">\n              <h4 class=\"" + styles["communityMemberSocialDetails-name"] + "\">" + contributor.Title + "</h4>\n              <p class=\"" + styles["communityMemberSocialTwitterWrapper"] + "\"><span class=\"socialLabelTwitter\">Twitter:</span> <a href=\"https://www.twitter.com/" + contributor.Twitter + "\" target=\"_blank\">@" + contributor.Twitter + "</a></p>\n              <p class=\"" + styles["communityMemberSocialBlogWrapper"] + "\"><span class=\"socialLabelBlog\">Blog:</span> <a href=\"" + contributor.Blog + "\" target=\"_blank\">" + contributor.Blog + "</a></p>\n            </div>\n          </div>\n        </div>\n      ";
            html += itemHTML;
        }
        return html;
    };
    Object.defineProperty(ZhPnPjsWebPart.prototype, "dataVersion", {
        get: function () {
            return Version.parse('1.0');
        },
        enumerable: true,
        configurable: true
    });
    ZhPnPjsWebPart.prototype.getPropertyPaneConfiguration = function () {
        return {
            pages: [
                {
                    header: {
                        description: strings.PropertyPaneDescription
                    },
                    groups: [
                        {
                            groupName: strings.BasicGroupName,
                            groupFields: [
                                PropertyPaneTextField('description', {
                                    label: strings.DescriptionFieldLabel
                                })
                            ]
                        }
                    ]
                }
            ]
        };
    };
    return ZhPnPjsWebPart;
}(BaseClientSideWebPart));
export default ZhPnPjsWebPart;
//# sourceMappingURL=ZhPnPjsWebPart.js.map