var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Version } from '@microsoft/sp-core-library';
import { BaseClientSideWebPart, PropertyPaneTextField } from '@microsoft/sp-webpart-base';
import styles from './ZhLibraryComponentWebPartWebPart.module.scss';
import * as strings from 'ZhLibraryComponentWebPartWebPartStrings';
import * as libraryComponent from 'zh-library-component';
var ZhLibraryComponentWebPartWebPart = /** @class */ (function (_super) {
    __extends(ZhLibraryComponentWebPartWebPart, _super);
    function ZhLibraryComponentWebPartWebPart() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ZhLibraryComponentWebPartWebPart.prototype.render = function () {
        var _this = this;
        this.domElement.innerHTML = "\n    <div class=\"" + styles.zhLibraryComponentWebPart + "\">\n    <div class=\"" + styles.container + "\">\n      <div class=\"" + styles.row + "\">\n        <div class=\"" + styles.column + "\">\n          <span class=\"" + styles.title + "\">Community Contributors</span>\n          <p class=\"" + styles.subTitle + "\">How many contributors would you like to see?\n            <select id=" + styles.communitySelect + " class=\"" + styles.communitySelectStyles + "\">\n              <option value=\"1\">1</option>\n              <option value=\"2\">2</option>\n              <option value=\"3\">3</option>\n              <option value=\"4\">4</option>\n              <option value=\"5\">5</option>\n              <option value=\"6\">6</option>\n              <option value=\"7\">7</option>\n              <option value=\"8\">8</option>\n              <option value=\"9\">9</option>\n              <option value=\"10\">10</option>\n            </select>\n          </p>\n          <a href=\"#\" class=\"" + styles.button + "\">\n            <span class=\"" + styles.label + "\">Retrieve Contributors</span>\n          </a>\n        </div>\n      </div>\n    </div>\n  </div>\n  <div id=\"" + styles.communityContributorsWrapper + "\"></div>";
        var btn = document.getElementsByClassName(styles.button);
        for (var _i = 0, _a = btn; _i < _a.length; _i++) {
            var button = _a[_i];
            button.addEventListener("click", function (e) { return _this.requestListItems(); });
        }
    };
    ZhLibraryComponentWebPartWebPart.prototype.requestListItems = function () {
        var _this = this;
        //#region - Obtain Coummunity Count
        // Normally you would not use an ID in a web part. This is used to keep the demo simple.
        var e = (document.getElementById(styles.communitySelect));
        var sel = e.selectedIndex;
        var opt = e.options[sel];
        var value = opt.value;
        //#endregion 
        var libCompInstance = new libraryComponent.ZhLibraryComponentLibrary();
        var pnpjs = libCompInstance.importPNPJS();
        pnpjs.sp.setup({
            spfxContext: this.context
        });
        pnpjs.sp.web.lists.getByTitle("CommunityContributors").items.select('Title', 'Twitter', 'Blog').orderBy('Created', true).top(opt.value).get().then(function (items) {
            console.log(items);
            _this.generateHTML(items);
        });
    };
    ZhLibraryComponentWebPartWebPart.prototype.generateHTML = function (listItems) {
        var html = '';
        for (var i = 0; i < listItems.length; i++) {
            var contributor = listItems[i];
            console.log(contributor);
            var itemHTML = "\n        <div class=\"" + styles["singleCommunityMember"] + "\">\n          <div class=\"" + styles["communityMemberInner"] + "\">\n            <div class=\"" + styles["communityMemberBiopic"] + "\"> \n              <span>\n                <img src=\"https://avatars.io/twitter/" + contributor.Twitter + "\"/>\n              </span> \n            </div>\n            <div class=\"" + styles["communityMemberSocialDetails"] + "\">\n              <h4 class=\"" + styles["communityMemberSocialDetails-name"] + "\">" + contributor.Title + "</h4>\n              <p class=\"" + styles["communityMemberSocialTwitterWrapper"] + "\"><span>Twitter:</span> <a href=\"https://www.twitter.com/" + contributor.Twitter + "\" target=\"_blank\">@" + contributor.Twitter + "</a></p>\n              <p class=\"" + styles["communityMemberSocialBlogWrapper"] + "\"><span>Blog:</span> <a href=\"" + contributor.Blog + "\" target=\"_blank\">" + contributor.Blog + "</a></p>\n            </div>\n          </div>\n        </div>\n      ";
            html += itemHTML;
        }
        document.getElementById(styles.communityContributorsWrapper).innerHTML = html;
        //return html;
    };
    Object.defineProperty(ZhLibraryComponentWebPartWebPart.prototype, "dataVersion", {
        get: function () {
            return Version.parse('1.0');
        },
        enumerable: true,
        configurable: true
    });
    ZhLibraryComponentWebPartWebPart.prototype.getPropertyPaneConfiguration = function () {
        return {
            pages: [
                {
                    header: {
                        description: strings.PropertyPaneDescription
                    },
                    groups: [
                        {
                            groupName: strings.BasicGroupName,
                            groupFields: [
                                PropertyPaneTextField('description', {
                                    label: strings.DescriptionFieldLabel
                                })
                            ]
                        }
                    ]
                }
            ]
        };
    };
    return ZhLibraryComponentWebPartWebPart;
}(BaseClientSideWebPart));
export default ZhLibraryComponentWebPartWebPart;
//# sourceMappingURL=ZhLibraryComponentWebPartWebPart.js.map